# neededforbuild  libpng libz svgalib xf86
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libpng libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace svgalib syslogd sysvinit texinfo textutils timezone unzip util-linux vim xdevel xf86 xshared

%define name povray
%define pvmname pvmpovray
%define mpiname mpipovray
%define version 3.1g
%define release 11mdk
%define pvmpov pvmpov3_1g_2
%define aimkpath /usr/share/pvm3/lib
%define mpipath mpipovray

Name:         	%{name}
License:      	povray
Version:        %{version}
Release:        %{release}
Group:        	Sciences/Computer science
Summary:      	Ray tracer
URL:	      	http://www.povray.org
BuildRoot:      %{_tmppath}/%name-buildroot
BuildRequires:	zlib1-devel, libpng3-devel

%description
The Persistence of Vision Ray tracer creates three-dimensional,
photo-realistic images using a rendering technique called ray tracing.
It reads in a text file containing information describing the objects and
lighting in a scene and generates an image of that scene from the view
point of a camera also described in the text file. Ray tracing is not
a fast process by any means, (the generation of a complex image can
take several hours) but it produces very high quality images
with realistic reflections, shading, perspective, and other effects.

%package common
Group:          Sciences/Computer science
Summary:        Ray tracer librairies

%description common
Common files for povray

%package official
Group:          Sciences/Computer science
Summary:        Ray tracer
Requires:	povray-common, libpng3
Source:         povuni_d.tgz
Source1:        povuni_s.tgz
Patch0:		povrayini.patch.bz2
Patch1:		makefile.patch.bz2
Patch2:		optout.patch.bz2
Patch9:		tunepov.patch.bz2
Patch12:	libdirs.patch.bz2

%description official
The Persistence of Vision Ray tracer creates three-dimensional,
photo-realistic images using a rendering technique called ray tracing.
It reads in a text file containing information describing the objects and
lighting in a scene and generates an image of that scene from the view
point of a camera also described in the text file. Ray tracing is not
a fast process by any means, (the generation of a complex image can
take several hours) but it produces very high quality images
with realistic reflections, shading, perspective, and other effects.

%package pvm
Group:          Sciences/Computer science
Summary:        Ray tracer 
Source2:	pvmpov-3.1g2.tgz
Source3:	chess2.pov
Source4:	chessItPvm
Requires:	povray-common, pvm, libpng3
BuildRequires:	libpvm-devel
URL:		http://sourceforge.net/projects/pvmpov
Patch3:		pvmmakefile.patch.bz2
Patch4:		pvmpovrayini.patch.bz2
Patch8:		pvmmakefile2.patch.bz2
Patch10:	tunepvmmakefile.patch.bz2
Patch13:	libdirs.pvm.patch.bz2

%description pvm
A parallel version of povray using pvm

%package mpich
Group:          Sciences/Computer science
Summary:        Ray tracer
Requires:       povray-common
Requires:       mpich, libpng3
URL:            http://www.verrall.demon.co.uk/mpipov
BuildRequires:	mpicc
Patch5:         mpi-povray-1.0.patch.bz2
Patch6:		mpioptout.patch.bz2
Patch7:		mpimakefile.patch.bz2
Patch11:	tunempimakefile.patch.bz2
Patch14:	libdirs.mpi.patch.bz2
Source5:	mpipovray.html
Source6:	chessItMpi

%description mpich
A parallel version of povray using mpi

%prep
rm -rf ${RPM_BUILD_ROOT}
rm -rf %{mpipath} 
rm -rf %{pvmpov} 
rm -rf %{name}31

#Uncompressing povray pvm
%setup -q -T -D -n %{pvmpov} -b 2 
%setup -q -T -D -n %{pvmpov} -a 1 
%setup -q -T -D -n %{pvmpov} -a 0
%patch3
%patch4
./inst-pvm
%patch8
%patch10
%patch13

#Uncompressing povray official
%setup -q -D -n povray31 -b 1
rm -rf ../%{mpipath}

#Copying povray to povray mpi path
mkdir -p ../%{mpipath}
cp ../povray31 ../%{mpipath} -af

#Patching povray official 
%patch0
%patch1
%patch2
%patch9
%patch12

#Apllying patches to povray mpi
cd ../%{mpipath}
%patch5
cd povray31
%patch0
%patch1
%patch6
%patch7
%patch11
%patch14

%build
#Official Build
cd source/unix
make newunix
make newxwin

%ifarch i386
	make newsvga
%endif

#Pvmpovray Build
cd ../../..
cd %{pvmpov}/povray31/source/pvm
export PATH=$PATH:%{aimkpath}
aimk newunix
aimk newxwin
%ifarch i386
	aimk newsvga
%endif

#Mpipovray build
cd ../../../../
cd %{mpipath}/povray31/source/mpi-unix
make newxwin

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/usr/{bin,X11R6/bin,lib/povray31}

##########################
#Installing official files
##########################
install -m 755 source/unix/povray $RPM_BUILD_ROOT%{_bindir}

# HACK: install the files as 644 so that find requires doesn't find them:
install -m 644 source/unix/x-povray $RPM_BUILD_ROOT/usr/X11R6/bin

install README.unix $RPM_BUILD_ROOT%{_libdir}/povray31
cp -a allscene include scenes $RPM_BUILD_ROOT%{_libdir}/povray31
cp -a *.ini povwhere.get allscene.sh  gamma.gif gamma.gif.txt $RPM_BUILD_ROOT%{_libdir}/povray31
cp -a xpovicon.xpm $RPM_BUILD_ROOT%{_libdir}/povray31

install -d $RPM_BUILD_ROOT/%{_mandir}/man1
install povray.1 $RPM_BUILD_ROOT/%{_mandir}/man1

############################
#Installing pvm povray files
############################
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{pvmname}/sample
install -m 644 ../%{pvmpov}/doc/* $RPM_BUILD_ROOT/%{_docdir}/%{pvmname}
install -m 755 ../%{pvmpov}/povray31/source/pvm/LINUX/pvmpov $RPM_BUILD_ROOT%{_bindir}
install -m 644 ../%{pvmpov}/povray31/source/pvm/LINUX/x-pvmpov $RPM_BUILD_ROOT/usr/X11R6/bin
install %{SOURCE3} $RPM_BUILD_ROOT/%{_docdir}/%{pvmname}/sample
install %{SOURCE4} $RPM_BUILD_ROOT/%{_docdir}/%{pvmname}/sample

#Installing file for i386 archictecture
%ifarch i386
	install -m 644 ../%{pvmpov}/povray31/source/unix/s-pvmpov $RPM_BUILD_ROOT%{_bindir}
%endif

############################
#Installing mpi povray files
############################
mkdir -p $RPM_BUILD_ROOT/%{_docdir}/%{mpiname}/sample
install -m 644 ../%{mpipath}/povray31/source/mpi-unix/mpi-x-povray $RPM_BUILD_ROOT/usr/X11R6/bin
install %{SOURCE3} $RPM_BUILD_ROOT/%{_docdir}/%{mpiname}/sample
install %{SOURCE6} $RPM_BUILD_ROOT/%{_docdir}/%{mpiname}/sample
install %{SOURCE5} $RPM_BUILD_ROOT/%{_docdir}/%{mpiname}

%files common
%defattr(-,root,root)
/usr/lib/povray31

%files official
%defattr(-,root,root)
%doc source/unix/README.unix povlegal.doc compile.doc CMPL_Unix.doc revision.doc 
%doc %{_mandir}/man1/povray.1.bz2
%attr(755,root,root) /usr/X11R6/bin/x-povray
%{_bindir}/povray

%ifarch i386
	%attr(755,root,root) %{_bindir}/s-povray
%endif

%files pvm
%defattr(-,root,root)
%doc source/unix/README.unix povlegal.doc compile.doc CMPL_Unix.doc revision.doc $RPM_BUILD_ROOT/%{_docdir}/%{pvmname}/sample $RPM_BUILD_ROOT/%{_docdir}/%{pvmname}/*
%doc %{_mandir}/man1/povray.1.bz2
%{_bindir}/pvmpov
%attr(755,root,root) /usr/X11R6/bin/x-pvmpov

%ifarch i386
	%attr(755,root,root) %{_bindir}/s-pvmpov
%endif

%files mpich
%defattr(-,root,root)
%doc source/unix/README.unix povlegal.doc compile.doc CMPL_Unix.doc revision.doc ../%{mpipath}/povray31/source/mpi-unix/README.MPI-Povray $RPM_BUILD_ROOT/%{_docdir}/%{mpiname}/* 
%doc %{_mandir}/man1/povray.1.bz2
%attr(755,root,root) /usr/X11R6/bin/mpi-x-povray

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Jul 04 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-11mdk
- Fixing chessIt sample script
- Renaming chessIt to chessItPvm
- Fixing buildrequires
- Fixing chessItMpi sample script

* Tue Jun 04 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-10mdk
- Fixing missing requires on libpng3

* Thu May 30 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-9mdk
- Fixing chessItMpi sample script

* Tue May 28 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-8mdk
- Renaming povray-mpi to povray-mpich because it's not compatible with lam
- Switching back to requires mpich for povray-mpi

* Mon May 27 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-7mdk
- Moving dependencies from "mpich" to "Mpi", now you can use povray-mpi with lam.

* Thu May 23 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-6mdk
- Gcc 3.1 build
- Fixing problem with a wrong libpng version

* Tue Apr 23 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-5mdk
- Fixing chessIt (mpi test script) for Mpi version of povray

* Fri Apr 12 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-4mdk
- Fixing wrong dependencies

* Thu Apr 11 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-3mdk
- Adding Mpi version of Povray as subpackage
- Fixing stupid mistakes
- Tuning compilation options (i586)

* Wed Apr 10 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-2mdk
- Fixing genpubkey script

* Fri Apr 05 2002 Erwan Velu <erwan@mandrakesoft.com> 3.1g-1mdk
- First build
